clear;close all;clc;
tic
rand('state',sum(100*clock));   %reset the random number generator

N=200;     % Number of points in each round-trip time                   
Nrt=12000; % The number of cycles in the OEO               
Nmax=10000; % The number of iterations to reach a steady state is (Nrt-Nmax)=2000                           
T=0.28e-6;%1.5*56/3e8; %round trip time (T is like tau=L/c in the paper )                 
R=50;
RFampCorr=1; %Correction factor to RF amplifier gain
P0=30e-3; %Input optical power
VpiAC=3.14;  %V_pi,AC                      
VpiDC=3.14; %V_pi_DC=3.14 V
Vb=3.14; %Bias voltage Vb              
eta=1;  %The parameter etha as in the paper                        
rhoDC=0.8; %responsivity of the photodetector at 10 GHz (A/W)           
rho=0.8;  %responsivity of the photodetector at DC (A/W)     
Ga=7.5;   %amplifier voltage gain             
attenRF=10^(0); %RF attenuation (default value = 1)
FilterLoss=10^(0); %Filter loss
Gwidth=20e6;  %The bandwidth of the filter (like Gamma in the paper)              
CouplerLoss=10^(0);
rho_N=10^(-20);
Gs=2.4;
alpha=(2*VpiDC*Gs)/(eta*pi*P0*rho*R*Ga); %insertion loss 

display(['Generating figure 11. Please wait.']);

[phase_noise,phase_noise_frq,v0_v,t_v,freq_v,phase_noise_RF,phi_v]=SingleOEO_main(N,Nrt,Nmax,T,alpha,RFampCorr,P0,VpiAC,VpiDC,Vb,eta,rhoDC,rho,Ga,...
    attenRF,FilterLoss,Gwidth,CouplerLoss,rho_N);

sim_end=toc;



figure(1);  %like figure 11 in the paper
plot(t_v./T,pi.*abs(v0_v)./VpiAC,'-b','LineWidth',1.5);
line(t_v./T,ones(1,length(t_v)).*2.03,'LineStyle','--','Color','r','LineWidth',1.5);
line(t_v./T,ones(1,length(t_v)).*2.76,'LineStyle','--','Color','r','LineWidth',1.5)
box off;
set(gca,'fontname','Times New Roman','fontsize',12);
xlim([0 4]); ylim([0 3]);
set(gca,'Xlim',[0 4],'Xtick',[0,1,2,3,4],'XtickLabel',{'0';'1';'2';'3';'4'});
y_tick=0:0.5:3;
set(gca,'Ylim',[0 3],'Ytick',y_tick,'YtickLabel',{'0';'';'1';'';'2';'';'3'});
xlabel('$T/\tau$','Interpreter','Latex','fontname','Times New Roman','fontsize',12);
ylabel('$\pi \left| {a_{in}^{\bmod } } \right|/V_\pi  $','Interpreter','Latex','fontname','Times New Roman','fontsize',12);



