clear;close all;clc;
tic
rand('state',sum(100*clock));   %reset the random number generator

N=200;     % Number of points in each round-trip time                   
Nrt=12000; % The number of cycles in the OEO               
Nmax=10000; % The number of iterations to reach a steady state is (Nrt-Nmax)=2000                           
T=0.28e-6;%1.5*56/3e8; %round trip time (T is like tau=L/c in the paper )                 
RFampCorr=1; %Correction factor to RF amplifier gain
P0=(10^1.477)*1e-3;%30e-3; %Input optical power 14.77 dBm
R=50;
VpiAC=3.14;  %V_pi,AC                      
VpiDC=3.14; %V_pi_DC=3.14 V
Vb=3.14; %Bias voltage Vb              
eta=1;  %The parameter etha as in the paper                        
rhoDC=0.8; %responsivity of the photodetector at 10 GHz (A/W)           
rho=0.8;  %responsivity of the photodetector at DC (A/W)     
Ga=7.5;   %amplifier voltage gain             
attenRF=10^(0); %RF attenuation (default value = 1)
FilterLoss=10^(0); %Filter loss
Gwidth=20e6;  %The bandwidth of the filter (like Gamma in the paper)              
CouplerLoss=10^(0);
rho_N=10^(-20);
Gs=1.5;
alpha=double((2*VpiDC*Gs)/(eta*pi*P0*rho*R*Ga)); %insertion loss                      

display(['Generating figure 2. Please wait.']);

[phase_noise,phase_noise_frq,v0_v,t_v,freq_v,phase_noise_RF,phi_v]=SingleOEO_main(N,Nrt,Nmax,T,alpha,RFampCorr,P0,VpiAC,VpiDC,Vb,eta,rhoDC,rho,Ga,...
    attenRF,FilterLoss,Gwidth,CouplerLoss,rho_N);


sim_end=toc;

f_start=find(freq_v>=10^1,1);
f_end=find(freq_v>=10^7,1);
f_end1=find(freq_v>=10^6,1);
freq_axis=freq_v(f_start:f_end);
f_axis=freq_v(f_start:f_end1);
phase_noise_axis=phase_noise(f_start:f_end);
phase_noise_axis1=phase_noise(f_start:f_end1);
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%figure 2 in the paper
A_m=[length(f_axis) sum(log10(f_axis))
    sum(log10(f_axis)) sum(log10(f_axis).^2)];
B_v=[sum(phase_noise_axis1), sum(log10(f_axis).*phase_noise_axis1)];
X_v=B_v/A_m;
y_fit2=X_v(1)+X_v(2).*log10(freq_axis);

y_fit=-55.5-20.*log10(freq_axis);

close all;
figure(1);
semilogx(freq_axis,phase_noise_axis,'-b','LineWidth',0.5);
hold on;
semilogx(freq_axis,y_fit,'-.k','LineWidth',1.5);
%hold off;
box off;
xlabel('Frequency offset (Hz)','fontname','Times New Roman','fontsize',12);
ylabel('Phase noise (dBc/Hz)','fontname','Times New Roman','fontsize',12);
set(gca,'fontname','Times New Roman','fontsize',12);
%set(gca,'Ylim',[-220 -100]);

%semilogx(freq_axis,y_fit2,'-m','LineWidth',0.5);
%figure;
% phase_noise_frq_axis=phase_noise_frq(f_start:f_end);
% semilogx(freq_axis,phase_noise_frq_axis,'-m','LineWidth',0.5);



